ctmin=0.01;
ctmax=100;

Zmmin=0.01;
Zmmax=100;

Nctot=36;
NZtot=36;

datadir='/data/septal/pwf25/czruns/july14/'; %%% Directory to which the code will write data when run; in this case, in my directory on septal.
mfiledir = '~/Documents/maths/polynyas/tex/Thesis/clean/code/createrunsoutput'; %%% Directory in which the code files will be created; in this case, on my laptop.

%%% "July" here and elsewhere has no significance beyond being the month in which I last did most of these runs.


%%%%%%%
% We choose values for Zm and ct spread evenly between the min and max values set above.
% The runs generated here will take a *long* time to run, but I believe it's set up to do the 
% faster runs first. An approximate estimate of run time (on a single core on a CMS computer)
% is in "hours"
%%%%%%%

Zmarr=Zmmin*(Zmmax/Zmmin).^( (0:(NZtot-1))/(NZtot-1));
ctarr=ctmin*(ctmax/ctmin).^( (0:(Nctot-1))/(Nctot-1));

dS=0.004;
Sm=4;

for iZ = 1:NZtot
    Zm=Zmarr(iZ);
    if Zm > 1
       dZ(iZ)=min(0.5, Zm/19); 
    else
        dZ(iZ)=max(0.005,Zm/19);
    end
    for ic=1:Nctot
        ct=ctarr(ic);
        dT(iZ,ic)=0.5*min([0.2*dZ(iZ)^2, 0.2*ct*dZ(iZ)/Sm, 0.1*ct*dS/1.4,0.001]);
%%% Max T chosen to be sufficient to always (for parameter values tested) reach steady state. 
        if ct<1
            Tm(iZ,ic)=20;
        else
            Tm(iZ,ic)=80*Zm^0.7*ct^0.3;
        end
        TN=Tm(iZ,ic)/dT(iZ,ic);
        operations(iZ,ic)=4*20*1000*TN;
        hours(iZ,ic)=operations(iZ,ic)/10000000/3600;
    end
end

% Could now do clever things to assign them, but for now...
Nruns=36;
Nrunsperrun=6;
for i=0:5
    for j = 0:5
        iZmin(6*i+j+1) = Nrunsperrun*i+1;
        iZmax(6*i+j+1) = Nrunsperrun*(i+1);
        icmin(6*i+j+1) = Nrunsperrun*j + 1;
        icmax(6*i+j+1) = Nrunsperrun*(j+1);
    end
end

%%%% Now we create the Nruns MATLAB scripts.
cd(mfiledir)
for ir=1:Nruns
    filename=['julrun' num2str(ir) '.m'];
    fid=fopen(filename,'w');
    fprintf(fid,'Ncruns = %u;\n',Nrunsperrun);
    fprintf(fid,'NZruns = %u;\n',Nrunsperrun);
    
    fprintf(fid,'ctarr = [');
    fprintf(fid,'%12.8f ', ctarr(icmin(ir):icmax(ir)));
    fprintf(fid,'];\n');
    
    fprintf(fid,'Zmarr = [');
    fprintf(fid,'%12.8f ', Zmarr(iZmin(ir):iZmax(ir)));
    fprintf(fid,'];\n');
    
    fprintf(fid,'dS = %8.6f;\n',dS);
    fprintf(fid,'Sm = %8.6f;\n', Smax);
    fprintf(fid, 'filebase = ''%sjulrun%u'';\n',datadir,ir);
    fprintf(fid, ['Thbs=zeros(NZruns,Ncruns);\n',...
'Thbm=zeros(NZruns,Ncruns);\n',...
'TatThbm=zeros(NZruns,Ncruns);\n',...
'for ic = 1:Ncruns\n',...
'    ct=ctarr(ic);\n',...
'    for iZ = 1:NZruns\n',...
'	tic;\n',...
'	Zm=Zmarr(iZ);\n',...
'	if Zm>1\n',...
'       dZ = min(0.5,Zm/19);\n',...
'    else\n',...
'       dZ = max(0.005,Zm/19);\n',...
'    end\n',...
'	if(ct>1)\n',...
'	  Tm=ct^0.3*80*Zm^0.7;\n',...
'	else\n',...
'         Tm=20;\n',...
'	end\n',...
'        dTpossibilities=[0.2*dZ^2, 0.2*ct*dZ/Sm, 0.1*ct*dS/1.4,0.001]\n',...
'	dT=0.5*min(dTpossibilities);\n',...
'        freq=ceil(1000/Tm)\n',...
'	Pstruct=Junefull(ct,Zm,dT,Tm,dS,Sm,dZ,freq);\n',...
'	Pstruct.ct=ct;\n',...
'	TN=length(Pstruct.T);\n',...
'	ZN=length(Pstruct.Z);\n',...
'	SN=length(Pstruct.S);\n',...
'       Pbar=zeros(SN,TN);\n',...
'        for s = 1:SN\n',...
'            for t=1:TN\n',...
'		Pbar(s,t)=Pstruct.dZ*mysum(Pstruct.P(s,:,t));\n',...
'            end\n',...
'        end\n',...
'        Sbarmax=zeros(TN,1);\n',...
'        for t = 1:TN\n',...
'            [~,I]=max(Pstruct.S''.^0.5.*Pbar(:,t));\n',...
'            Sbarmax(t)=Pstruct.S(I);\n',...
'        end\n',...
'        timeseries(iZ,ic).Sbarmax=Sbarmax;\n',...
'        timeseries(iZ,ic).T=Pstruct.T;\n',...
'        Thbar=zeros(1,TN);\n',...
'        for t=1:TN\n',...
'            Thbar(t)=mysum(Pstruct.Th(:,t))*Pstruct.dZ;\n',...
'        end\n',...
'        timeseries(iZ,ic).Thbar=Thbar;\n',...
'	[Thbm(iZ,ic),I]=max(Thbar);\n',...
'        TatThbm(iZ,ic)=Pstruct.T(I);\n',...
'        Thbs(iZ,ic)=Thbar(end);\n',...
'	Zseries(iZ,ic).Thsteady=Pstruct.Th(:,end);\n',...
'        Zseries(iZ,ic).Z=Pstruct.Z;\n',...
'        Lsteady=zeros(1,ZN);\n',...
'        for z=1:ZN\n',...
'            Lsteady(z)=Pstruct.dS*mysum(Pstruct.P(:,z,end).*...\n',...
'                Pstruct.S''.^0.5)*Pstruct.Th(z,end);\n',...
'            for t=1:TN\n',...
'                n(z,t)=Pstruct.dS*mysum(Pstruct.P(:,z,t))/Zm;\n',...
'            end\n',...
'	end\n',...
'        nbar=zeros(1,TN);\n',...
'        for t=1:TN\n',...
'            nbar(t)=Pstruct.dZ*mysum(n(:,t));\n',...
'        end\n',...
'        Zseries(iZ,ic).Lsteady=Lsteady;\n',...
'        timeseries(iZ,ic).nbar=nbar;\n',...
'                Sseries(iZ,ic).S=Pstruct.S;\n',...
'        Sseries(iZ,ic).Pbarend=Pbar(:,end);\n',...
'        toc\n',...
'        myfilename=[filebase, ''_c'' , num2str(ic) , ''_Z'' , num2str(iZ)]\n',...
'        save(myfilename,''Pstruct'');\n',...
'        clear Pstruct;\n',...
'        save([filebase, ''basic''])\n',...
'    end\n',...
'end\n',...
'\n',...
'exit;\n']);



fclose(fid);
end

